; Dieser Quellcode zeigt, wie man die DLL von Operno verwendet.
; Zuserst mssen wir eine Quelldatei einbinden, die alle Befehle
; der DLL importiert und fr die Nutzung vorbereitet:
IncludeFile "..\Operno.pbi"

; Nun mssen wir Operno nur noch initialisieren:
InitOperno()



; Probieren wir mal gleich das Rechnen mit Operno aus:
Debug "  Aufgaben:"
Debug "1 + 1 + 1 ="
Debug OpernoEvalI("1 + 1 + 1")
Debug "2 + 3 * 4 ="
Debug OpernoEvalI("2 + 3 * 4")
Debug "(4 + 4) / 2 ="
Debug OpernoEvalI("(4 + 4) / 2")

; Auch Floats lassen sich berechnen:
Debug "-------------------------------"
Debug "  Aufgaben mit Floats:"
Debug "10.0 / 4 ="
Debug OpernoEvalF("10.0 / 4")
Debug "8.1 * 0.1 ="
Debug OpernoEvalF("5.0 * 0.1")

; Natrlich sind auch Quad, Doubles und Strings mglich (...Execute- Q,D,S).



; Versuchen wir mal Objekte zu definieren und diese auch zu nutzen:
Debug "-------------------------------"
Debug "Variable definieren:"
Debug "x = 123"
X = OpernoCreateIVariable("x", 123, *OpernoMainObject)
; "MainObject" ist ein Zeiger auf die Hauptgruppe.
; Dort sind alle globalen Objekte definiert. Die Variable
; "X" in PureBasic besitzt die ID des neuen Objekts.

Debug "-------------------------------"
Debug "Variable nutzen:"
Debug "x - 3 - 20 ="
Debug OpernoEvalI("x - 3 - 20")

; Wir knnen auch die Variable ber Operno modifizeren und den
; Wert von x durch PureBasic ermitteln:
Debug "-------------------------------"
Debug "Variable modifizieren:"
Debug "x = 300 + 20 + 1"
OpernoEval("x = 300 + 20 + 1")
Debug "x = "
Debug OpernoVariableI(X)



; Wir knnen auch Funktionen in Operno definieren:
Procedure.i MeinMessageRequester()
  Protected Titel.String,Text.String
  
  OpernoPopSValue(@Titel) ;Ersten Parameter ermitteln.
  OpernoPopSValue(@Text)  ;Zweiten Parameter ermitteln.
  
  MessageRequester(Titel\S,Text\S)
EndProcedure
; Diese Funktion stellen wir als Objekt bereit:
MessageRequesterFunction = OpernoCreateFunction("messageRequester", @MeinMessageRequester(), *OpernoMainObject)
; Rufen wir die Funktion auf:
Debug "-------------------------------"
Debug "Eigene Funktion aufrufen:"
Debug "message requester(" + Chr(34) + "Nachricht" + Chr(34) + ", " + Chr(34) + "Hallo Welt!" + Chr(34) + ")"
OpernoEval("message requester(" + Chr(34) + "Nachricht" + Chr(34) + ", " + Chr(34) + "Hallo Welt!" + Chr(34) + ")")
; Die Funktion werden wir nicht mehr gebrauchen.
; Daher wird dieses mittels ID gelscht:
OpernoFreeObject(MessageRequesterFunction)



; Definieren wir nun eine Funktion namens "min". Der kleinste
; Wert von mehreren Werten wird zurckgeben:
Procedure.i Minima()
  Protected FirstNumber.Float, SecondNumber.Float
  
  OpernoPopFValue(@FirstNumber)
  OpernoPopFValue(@SecondNumber)
  
  If FirstNumber\F < SecondNumber\F
    ProcedureReturn OpernoPushFValue(FirstNumber\F)
  Else
    ProcedureReturn OpernoPushFValue(SecondNumber\F)
  EndIf
EndProcedure
; Funktion in Operno als Objekt erstellen:
MinimaFunction = OpernoCreateFunction("minima", @Minima(), *OpernoMainObject)
; Da diese Funktion auch als "min" bekannt ist, definieren
; wir eine Referenz auf diese Funktion:
MinFunction = OpernoCreateReferenceObject("min", MinimaFunction, *OpernoMainObject)
; Auch diese wird aufgerufen:
Debug "-------------------------------"
Debug "minima(2, 8) = "
Debug OpernoEvalF("minima(2, 8)")
Debug "min(10, 4) = "
Debug OpernoEvalF("min(10, 4)")
;Debug OpernoEvalF("min(10, 4)")
; Die Funktion und dessen Referenz lschen:
OpernoFreeObject(MinFunction)
OpernoFreeObject(MinimaFunction)



; Operno lsst auch dynamische Listen zu. Man kann diese durch
; bestimmte Befehle analysieren und sogar selbst erstellen.
; Folgendes Beispiel zeigt, wie man jedes Element einer gegebenen
; Liste ausgibt:
Procedure.i DisplayItems()
  Protected Queue.i, Item.i, Value.i
  
  ; Zuerst speichern wir die Adresse des Arguments in "queue",
  ; damit wir einen schnellen Zugriff besitzen:
  OpernoPopValue(@Queue)
  
  ; Danach berprfen wir mittels Adresse, ob das gegebene
  ; Argument berhaupt eine Liste ist:
  If OpernoValueClass(Queue) = *OpernoQueueClass
    ; Nun ermitteln wir das erste Element, um durch eine Schleife
    ; bis zum Ende einen Durchlauf zu ermglichen:
    Item = OpernoFirstItem(Queue)
    ; Wurde das letzte Element bereist erreicht und es wird
    ; trotzdem "OpernoNextItem" verwendet, so wird Null zurckgegeben.
    ; Dadurch kann man einen Listen-Durchlauf mit einer
    ; While-Schleife programmieren:
    While Item
      Value = OpernoItemValue(Item) ;Wert des Elements zurckgeben
      Select OpernoValueClass(Value)
        Case *OpernoIntegerClass
          ; Einen Integer ausgeben:
          Debug Str(OpernoValueI(Value))
        Case *OpernoFloatClass
          ; Einen Float ausgeben:
          Debug StrF(OpernoValueF(Value))
        Case *OpernoStringClass
          ; Eine Zeichenkette ausgeben:
          Debug Chr(34) + OpernoValueS(Value) + Chr(34)
      EndSelect
      ; Zum nchsten Element springen:
      Item = OpernoNextItem(Item)
    Wend
  Else
    Debug "Invalid parameter typed!"
  EndIf
EndProcedure
; Legen wir diese Funktion als Objekt an:
DisplayItemsFunction = OpernoCreateFunction("displayItems", @DisplayItems(), *OpernoMainObject)
; Wenden wir die Funktion an:
Debug "-------------------------------"
Debug "display items([1, 2, 3])"
OpernoEval("display items([1, 2, 3])")
; Hier wird man eine beabsichtigte Fehlermeldung ausgeben:
Debug "display items(123)"
OpernoEval("display items(123)")
; Die Funktion wird aus Operno gelscht:
OpernoFreeObject(DisplayItemsFunction)







; Dies waren alle wichtigen Features der DLL. Operno verfgt
; ber noch mehr Funktionen, die jedoch nicht gut oder gar
; nicht dokumentiert sind. Im Beispiel "Squares.pb" kann man
; sehen, wie man Klassen definiert und Quellcodes aus der
; Festplatte ausfhrt.
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 119
; FirstLine = 117
; Folding = -
; EnableXP