IncludeFile "Operno.pbi"



Global MIDI.i
Global *MIDILibrary.OpernoObject



Procedure.i SendMIDIMessage(Status.i, Channel.i, Param1.i, Param2.i)
  ProcedureReturn midiOutShortMsg_(MIDI, Status|Channel|(Param1 << 8)|(Param2 << 16))
EndProcedure

Procedure.i Std_MIDI_SetInstrument()
  Protected Instrument.i, Channel.i
  
  Select OpernoArgumentCount()
    Case 2
      OpernoPopIValue(@Instrument)
      OpernoPopIValue(@Channel)
    Case 1
      OpernoPopIValue(@Instrument)
      Channel = 0
    Case 0
      _OpernoArgumentError(1)
  EndSelect
  
  SendMIDIMessage($C0, Channel, Instrument, 0)
EndProcedure
Procedure.i Std_MIDI_Play()
  Protected Note.i, Velocity.i, Channel.i
  
  Select OpernoArgumentCount()
    Case 3
      OpernoPopIValue(@Note)
      OpernoPopIValue(@Velocity)
      OpernoPopIValue(@Channel)
    Case 2
      OpernoPopIValue(@Note)
      OpernoPopIValue(@Velocity)
      Channel = 0
    Case 1
      OpernoPopIValue(@Note)
      Velocity = 100
      Channel  = 0
    Case 0
      Note     = 64
      Velocity = 100
      Channel  = 0
  EndSelect
  
  SendMIDIMessage($90, Channel, Note, Velocity)
EndProcedure
Procedure.i Std_MIDI_Stop()
  Protected Note.i, Channel.i
  
  Select OpernoArgumentCount()
    Case 2
      OpernoPopIValue(@Note)
      OpernoPopIValue(@Channel)
    Case 1
      OpernoPopIValue(@Note)
      Channel = 0
    Case 0
      Note    = 64
      Channel = 0
  EndSelect
  
  SendMIDIMessage($90, Channel, Note, 0)
EndProcedure



ProcedureDLL.i InitLibrary()
  Protected Caps.MIDIOUTCAPS, Devices.i = midiOutGetNumDevs_()
  Protected DeviceIndex.i, Port.i
  
  For DeviceIndex = - 1 To Devices - 1
    If midiOutGetDevCaps_(DeviceIndex, @Caps, SizeOf(MIDIOUTCAPS)) = 0
      If Caps\wVoices > 0
        Port = DeviceIndex
      EndIf
    EndIf
  Next
  
  If midiOutOpen_(@MIDI, Port, 0, 0, 0) = #MMSYSERR_NOERROR
    *MIDILibrary = OpernoCreateGroup("midi", *OpernoStandardLibrary)
    OpernoExtractObject(*MIDILibrary, ?Std_MIDI)
  EndIf
EndProcedure
ProcedureDLL.i MIDILibrary()
  ProcedureReturn *MIDILibrary
EndProcedure



DataSection
  Std_MIDI:
    Data.c #OpernoObject_Function : Data.s "setInstrument" ;{
      Data.i @Std_MIDI_SetInstrument()
    ;}
    Data.c #OpernoObject_Function : Data.s "play" ;{
      Data.i @Std_MIDI_Play()
    ;}
    Data.c #OpernoObject_Function : Data.s "stop" ;{
      Data.i @Std_MIDI_Stop()
    ;}
    Data.c #Null
EndDataSection

; IDE Options = PureBasic 4.40 Beta 4 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 92
; FirstLine = 66
; Folding = -5
; EnableXP
; Executable = ..\midi.dll