;**************************************************************
;     Array (class)
;
; Author: Josef Sniatecki
; Creation date: 29.01.2010
;**************************************************************
;   Copyright (c) 2010 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i Std_Array__New()
  *Current\This\Std_Array = _New(Std_Array)
  *Current\This\Scope     | #Value_Binary
EndProcedure
Procedure.i Std_Array__Def()
  Protected *This.Std_Array = *Current\This\Std_Array
  Protected Index.i, *Pointer.Integer, *Class.Object
  
  If PopIValue(@*This\Size)
    *This\Entries = _Dim(*This\Size * _Sz(Integer))
    *Pointer      = *This\Entries
    
    *Class = *VariantClass
    PopPValue(@*Class)
    For Index = 1 To *This\Size
      *Pointer\I = CreateValue(*Class)
      *Pointer   + _Sz(Integer)
    Next
  Else
    _ErrorP(1)
  EndIf
EndProcedure
Procedure.i Std_Array__Del()
  Protected *This.Std_Array = *Current\This\Std_Array
  Protected Index.i, *Pointer.Integer
  
  *Pointer = *This\Entries
  For Index = 1 To *This\Size
    FreeValue(*Pointer\I)
    *Pointer + _Sz(Integer)
  Next
  
  _Free(*This\Entries)
  _Free(*This)
EndProcedure
Procedure.i Std_Array__Form()
  Protected *This.Std_Array = *Current\This\Std_Array
  Protected Index.i, *Pointer.Integer
  Protected String.s
  Protected Value.s, Line.s
  
  String = "("
  
  *Pointer = *This\Entries
  For Index = 1 To *This\Size
    Value = FormatValue(*Pointer\I)
    *Pointer + _Sz(Integer)
    
    If CountString(Value, #N)
      If Line
        String + Line + "," + #N + " "
        Line = ""
      EndIf
      String + ReplaceString(Value, #N, #N + " ")
      If Index < *This\Size
        String + "," + #N + " "
      EndIf
    ElseIf Len(Line) + Len(Value) > 30
      String + Line + Value
      Line = ""
      If Index < *This\Size
        String + "," + #N + " "
      EndIf
    Else
      Line + Value
      If Index < *This\Size
        Line + ", "
      EndIf
    EndIf
  Next
  
  String + Line + ")"
    
  ProcedureReturn PushSValue(String)
EndProcedure
Procedure.i Std_Array__Args()
  Protected *This.Std_Array = *Current\This\Std_Array
  Protected Index.i, *Pointer.Integer, *Queue.Queue
  
  If PopIValue(@Index)
    ProcedureReturn PeekI(*This\Entries + Index * _Sz(Integer))
  Else
    *Queue = CreateQueue(@FreeValue())
    *Pointer = *This\Entries
    For Index = 1 To *This\Size
      AppendQueueItem(*Queue, CreateReferenceValue(*Pointer\I))
      *Pointer + _Sz(Integer)
    Next
    ProcedureReturn PushQueueValue(*Queue)
  EndIf
EndProcedure
Procedure.i Std_Array__Vec()
  Protected *This.Std_Array = *Current\This\Std_Array
  Protected Index.i, *Pointer.Integer, *Queue.Queue
  
  *Queue = CreateQueue(@FreeValue())
  *Pointer = *This\Entries
  For Index = 1 To *This\Size
    AppendQueueItem(*Queue, CreateReferenceValue(*Pointer\I))
    *Pointer + _Sz(Integer)
  Next
  ProcedureReturn PushQueueValue(*Queue)
EndProcedure



DataSection
  ArrayClass:
    Data.c #Object_Function : Data.s _CM(new) ;{
      Data.i @Std_Array__New()
    ;}
    Data.c #Object_Function : Data.s _CM(def) ;{
      Data.i @Std_Array__Def()
    ;}
    Data.c #Object_Function : Data.s _CM(del) ;{
      Data.i @Std_Array__Del()
    ;}
    Data.c #Object_Function : Data.s _CM(form) ;{
      Data.i @Std_Array__Form()
    ;}
    Data.c #Object_Function : Data.s _CM(args) ;{
      Data.i @Std_Array__Args()
    ;}
    Data.c #Object_Function : Data.s _CM(vec) ;{
      Data.i @Std_Array__Vec()
    Data.s _CM(it)
    ;}
    Data.c #False
EndDataSection
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 150
; FirstLine = 115
; Folding = ---
; EnableXP