;**************************************************************
;     Double (class)
;
; Autor: Josef Sniatecki
; Creation date: 08.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i Std_Double_Abs()
  If *Current\This\Double\D < 0
    ProcedureReturn PushDValue(-*Current\This\Double\D)
  Else
    ProcedureReturn PushDValue(*Current\This\Double\D)
  EndIf
EndProcedure
Procedure.i Std_Double_DoAbs()
  If *Current\This\Double\D < 0
    _Inv(*Current\This\Double\D)
  EndIf
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Double__New()
  *Current\This\Double = _New(Double)
  *Current\This\Scope  | #Value_Binary
EndProcedure
Procedure.i Std_Double__Def()
  PopDValue(*Current\This\Double)
EndProcedure
Procedure.i Std_Double__Del()
  FreeMemory(*Current\This\Memory)
EndProcedure
Procedure.i Std_Double__IsTrue()
  If *Current\This\Double\D
    ProcedureReturn PushBValue(#True)
  Else
    ProcedureReturn PushBValue(#False)
  EndIf
EndProcedure
Procedure.i Std_Double__Set()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Double\D = *Value\Integer\I
    Case *FloatClass
      *Current\This\Double\D = *Value\Float\F
    Case *QuadClass
      *Current\This\Double\D = *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Double\D = *Value\Double\D
    Case *StringClass
      *Current\This\Double\D = ValD(*Value\String\S)
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Double__Add()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      ProcedureReturn PushDValue(*Current\This\Double\D + *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushDValue(*Current\This\Double\D + *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushDValue(*Current\This\Double\D + *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Double\D + *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Double__Sub()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      ProcedureReturn PushDValue(*Current\This\Double\D - *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushDValue(*Current\This\Double\D - *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushDValue(*Current\This\Double\D - *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Double\D - *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Double__Neg()
  ProcedureReturn PushFValue(-*Current\This\Double\D)
EndProcedure
Procedure.i Std_Double__Mul()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      ProcedureReturn PushDValue(*Current\This\Double\D * *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushDValue(*Current\This\Double\D * *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushDValue(*Current\This\Double\D * *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Double\D * *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Double__Div()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass
      ProcedureReturn PushDValue(*Current\This\Double\D / *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushDValue(*Current\This\Double\D / *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushDValue(*Current\This\Double\D / *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Double\D / *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Double__Pow()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass
      ProcedureReturn PushDValue(Pow(*Current\This\Double\D, *Value\Integer\I))
    Case *FloatClass
      ProcedureReturn PushDValue(Pow(*Current\This\Double\D, *Value\Float\F))
    Case *QuadClass
      ProcedureReturn PushDValue(Pow(*Current\This\Double\D, *Value\Quad\Q))
    Case *DoubleClass
      ProcedureReturn PushDValue(Pow(*Current\This\Double\D, *Value\Double\D))
  EndSelect
EndProcedure
Procedure.i Std_Double__DoAdd()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Double\D + *Value\Integer\I
    Case *FloatClass
      *Current\This\Double\D + *Value\Float\F
    Case *QuadClass
      *Current\This\Double\D + *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Double\D + *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Double__DoSub()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Double\D - *Value\Integer\I
    Case *FloatClass
      *Current\This\Double\D - *Value\Float\F
    Case *QuadClass
      *Current\This\Double\D - *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Double\D - *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Double__DoMul()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Double\D * *Value\Integer\I
    Case *FloatClass
      *Current\This\Double\D * *Value\Float\F
    Case *QuadClass
      *Current\This\Double\D * *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Double\D * *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Double__DoDiv()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Double\D / *Value\Integer\I
    Case *FloatClass
      *Current\This\Double\D / *Value\Float\F
    Case *QuadClass
      *Current\This\Double\D / *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Double\D / *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Double__Eq()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Double\D = *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *FloatClass
      If *Current\This\Double\D = *Value\Float\F
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *QuadClass
      If *Current\This\Double\D = *Value\Quad\Q
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *DoubleClass
      If *Current\This\Double\D = *Value\Double\D
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Double__Le()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Double\D < *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *FloatClass
      If *Current\This\Double\D < *Value\Float\F
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *QuadClass
      If *Current\This\Double\D < *Value\Quad\Q
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *DoubleClass
      If *Current\This\Double\D < *Value\Double\D
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Double__Gr()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Double\D > *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *FloatClass
      If *Current\This\Double\D > *Value\Float\F
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *QuadClass
      If *Current\This\Double\D > *Value\Quad\Q
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *DoubleClass
      If *Current\This\Double\D > *Value\Double\D
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Double__Inc()
  *Current\This\Double\D + 1
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Double__Dec()
  *Current\This\Double\D - 1
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Double__Form()
  Protected *Pointer.Character, String.s
  
  String = StrD(*Current\This\Double\D)
  ; Count the zeros on the right:
  *Pointer = @String + Len(String)-1
  While *Pointer\C = '0'
    *Pointer-1
  Wend
  If *Pointer\C = '.'
    *Pointer-1
  EndIf
  ; Remove the zeros:
  String = Left(String, *Pointer-@String + 1)
  
  ProcedureReturn PushSValue(String)
EndProcedure

DataSection
  DoubleClass:
    Data.c #Object_Function : Data.s "abs" ;{
      Data.i @Std_Double_Abs()
    ;}
    Data.c #Object_Function : Data.s "abs!" ;{
      Data.i @Std_Double_DoAbs()
    ;}
    Data.c #Object_Function : Data.s _CM(new) ;{
      Data.i @Std_Double__New()
    ;}
    Data.c #Object_Function : Data.s _CM(def) ;{
      Data.i @Std_Double__Def()
    ;}
    Data.c #Object_Function : Data.s _CM(del) ;{
      Data.i @Std_Double__Del()
    ;}
    Data.c #Object_Function : Data.s _CM(true?) ;{
      Data.i @Std_Double__IsTrue()
    ;}
    Data.c #Object_Function : Data.s _CM(set) ;{
      Data.i @Std_Double__Set()
    ;}
    Data.c #Object_Function : Data.s _CM(add) ;{
      Data.i @Std_Double__Add()
    ;}
    Data.c #Object_Function : Data.s _CM(sub) ;{
      Data.i @Std_Double__Sub()
    ;}
    Data.c #Object_Function : Data.s _CM(neg) ;{
      Data.i @Std_Double__Neg()
    Data.s "negative"
    ;}
    Data.c #Object_Function : Data.s _CM(mul) ;{
      Data.i @Std_Double__Mul()
    ;}
    Data.c #Object_Function : Data.s _CM(div) ;{
      Data.i @Std_Double__Div()
    ;}
    Data.c #Object_Function : Data.s _CM(pow) ;{
      Data.i @Std_Double__Pow()
    ;}
    Data.c #Object_Function : Data.s _CM(add!) ;{
      Data.i @Std_Double__DoAdd()
    ;}
    Data.c #Object_Function : Data.s _CM(sub!) ;{
      Data.i @Std_Double__DoSub()
    ;}
    Data.c #Object_Function : Data.s _CM(mul!) ;{
      Data.i @Std_Double__DoMul()
    ;}
    Data.c #Object_Function : Data.s _CM(div!) ;{
      Data.i @Std_Double__DoDiv()
    ;}
    Data.c #Object_Function : Data.s _CM(eq) ;{
      Data.i @Std_Double__Eq()
    ;}
    Data.c #Object_Function : Data.s _CM(le) ;{
      Data.i @Std_Double__Le()
    ;}
    Data.c #Object_Function : Data.s _CM(gr) ;{
      Data.i @Std_Double__Gr()
    ;}
    Data.c #Object_Function : Data.s _CM(inc) ;{
      Data.i @Std_Double__Inc()
    ;}
    Data.c #Object_Function : Data.s _CM(dec) ;{
      Data.i @Std_Double__Dec()
    ;}
    Data.c #Object_Function : Data.s _CM(form) ;{
      Data.i @Std_Double__Form()
    ;}
    Data.c #False
EndDataSection

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = --------
; EnableXP