;**************************************************************
;     Exports
;
; Autor: Josef Sniatecki
; Creation date: 06.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



ProcedureDLL.i OpernoFunctionTable()
  ProcedureReturn ?FunctionTable
EndProcedure

; START:
ProcedureDLL.i OpernoMainObject()
  ProcedureReturn Main\Object
EndProcedure
ProcedureDLL.i OpernoPreprocessorObject()
  ProcedureReturn *PreprocessorObject
EndProcedure
ProcedureDLL.i OpernoStandardLibrary()
  ProcedureReturn *StandardLibrary
EndProcedure
ProcedureDLL.i OpernoStandardClassLibrary()
  ProcedureReturn *StandardClassLibrary
EndProcedure
ProcedureDLL.i OpernoIntegerClass()
  ProcedureReturn *IntegerClass
EndProcedure
ProcedureDLL.i OpernoFloatClass()
  ProcedureReturn *FloatClass
EndProcedure
ProcedureDLL.i OpernoQuadClass()
  ProcedureReturn *QuadClass
EndProcedure
ProcedureDLL.i OpernoDoubleClass()
  ProcedureReturn *DoubleClass
EndProcedure
ProcedureDLL.i OpernoBoolClass()
  ProcedureReturn *BooleanClass
EndProcedure
ProcedureDLL.i OpernoStringClass()
  ProcedureReturn *StringClass
EndProcedure
ProcedureDLL.i OpernoQueueClass()
  ProcedureReturn *QueueClass
EndProcedure
ProcedureDLL.i OpernoBlockClass()
  ProcedureReturn *BlockClass
EndProcedure
ProcedureDLL.i OpernoPointerClass()
  ProcedureReturn *PointerClass
EndProcedure
ProcedureDLL.i OpernoObjectClass()
  ProcedureReturn *ObjectClass
EndProcedure

ProcedureDLL.i OpernoThis()
  ProcedureReturn *Current\This
EndProcedure
ProcedureDLL.i OpernoMemory()
  ProcedureReturn *Current\This\Memory
EndProcedure
ProcedureDLL.i OpernoTable()
  ProcedureReturn *Current\This\Object\Group + _Sz(Object)
EndProcedure
ProcedureDLL.s OpernoClassName(*Class.Object)
  _ReturnDLLString(ClassName(*Class))
EndProcedure

ProcedureDLL.i OpernoOpenLevel(*ArgumentQueue.Queue, *Object.Object, *This.Value)
  OpenLevel(0, *ArgumentQueue, *Object, *This, #True)
EndProcedure
ProcedureDLL.i OpernoUseObject(*Object.Object)
  OpenLevel(0, 0, *Object, 0, #True)
EndProcedure
ProcedureDLL.i OpernoCloseLevel()
  CloseLevel()
EndProcedure
ProcedureDLL.i OpernoClearStack()
  ClearStack()
EndProcedure
ProcedureDLL.i OpernoTruncation()
  ProcedureReturn Truncation
EndProcedure
ProcedureDLL.i OpernoSetTruncation(Level.i)
  Truncation = Level
EndProcedure
ProcedureDLL.i OpernoExit()
  Truncation = #Truncation_End
EndProcedure

ProcedureDLL.i OpernoError()
  ProcedureReturn Error
EndProcedure
ProcedureDLL.s OpernoErrorMessage()
  Error = #False
  DLLString = ErrorMessage
  ErrorMessage = ""
  ProcedureReturn DLLString
EndProcedure
ProcedureDLL.i OpernoRaiseError(Message.s)
  Error(Message)
EndProcedure

ProcedureDLL.i OpernoEval(Code.s)
  ProcedureReturn Execute(Code, 0, #True)
EndProcedure
ProcedureDLL.i OpernoEvalI(Code.s)
  ProcedureReturn ExecuteI(Code, 0, #True)
EndProcedure
ProcedureDLL.f OpernoEvalF(Code.s)
  ProcedureReturn ExecuteF(Code, 0, #True)
EndProcedure
ProcedureDLL.q OpernoEvalQ(Code.s)
  ProcedureReturn ExecuteQ(Code, 0, #True)
EndProcedure
ProcedureDLL.d OpernoEvalD(Code.s)
  ProcedureReturn ExecuteD(Code, 0, #True)
EndProcedure
ProcedureDLL.s OpernoEvalS(Code.s)
  _ReturnDLLString(ExecuteS(Code, 0, #True))
EndProcedure
ProcedureDLL.i OpernoEvalCommands(Code.s)
  ProcedureReturn ExecuteCommands(Code, 0, #True)
EndProcedure
ProcedureDLL.i OpernoEvalFile(Name.s)
  ProcedureReturn ExecuteFile(Name)
EndProcedure

ProcedureDLL.i OpernoParse(Code.s)
  Protected *TokenQueue.Queue
  
  *TokenQueue = CreateQueue(@FreeToken())
  Parse(*TokenQueue, @Code)
  
  ProcedureReturn *TokenQueue
EndProcedure
ProcedureDLL.i OpernoRun(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = Run()
  CloseLevel()
  
  ProcedureReturn *Result
EndProcedure
ProcedureDLL.i OpernoRunI(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = Run()
  CloseLevel()
  
  ProcedureReturn ValueI(*Result)
EndProcedure
ProcedureDLL.f OpernoRunF(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = Run()
  CloseLevel()
  
  ProcedureReturn ValueF(*Result) 
EndProcedure
ProcedureDLL.q OpernoRunQ(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = Run()
  CloseLevel()
  
  ProcedureReturn ValueQ(*Result) 
EndProcedure
ProcedureDLL.d OpernoRunD(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = Run()
  CloseLevel()
  
  ProcedureReturn ValueD(*Result)
EndProcedure
ProcedureDLL.s OpernoRunS(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = Run()
  CloseLevel()
  
  _ReturnDLLString(ValueS(*Result))
EndProcedure
ProcedureDLL.i OpernoRunCommands(*TokenQueue.Queue)
  Protected *Result.Value
  
  OpenLevel(*TokenQueue, 0, 0, 0, #True)
    *Result = RunCommands()
  CloseLevel()
  
  ProcedureReturn *Result
EndProcedure
ProcedureDLL.i OpernoFreeTokenQueue(*TokenQueue.Queue)
  FreeQueue(*TokenQueue)
EndProcedure

ProcedureDLL.i OpernoValueClass(*Value.Value)
  ProcedureReturn *Value\Class
EndProcedure  
ProcedureDLL.i OpernoValueMemory(*Value.Value)
  ProcedureReturn *Value\Memory
EndProcedure
ProcedureDLL.i OpernoValueI(*Value.Value)
  ProcedureReturn ValueI(*Value)
EndProcedure
ProcedureDLL.f OpernoValueF(*Value.Value)
  ProcedureReturn ValueF(*Value)
EndProcedure
ProcedureDLL.q OpernoValueQ(*Value.Value)
  ProcedureReturn ValueQ(*Value)
EndProcedure
ProcedureDLL.d OpernoValueD(*Value.Value)
  ProcedureReturn ValueD(*Value)
EndProcedure
ProcedureDLL.i OpernoValueB(*Value.Value)
  ProcedureReturn ValueB(*Value)
EndProcedure
ProcedureDLL.s OpernoValueS(*Value.Value)
  _ReturnDLLString(ValueS(*Value))
EndProcedure
ProcedureDLL.i OpernoValueP(*Value.Value)
  ProcedureReturn ValueP(*Value)
EndProcedure
ProcedureDLL.i OpernoValueScope(*Value.Value)
  ProcedureReturn *Value\Scope
EndProcedure
ProcedureDLL.i OpernoSetValueScope(*Value.Value, Scope.i)
  *Value\Scope = Scope
EndProcedure
ProcedureDLL.i OpernoAddValueScope(*Value.Value, Scope.i)
  *Value\Scope|Scope
EndProcedure
ProcedureDLL.s OpernoValueName(*Value.Value)
  _ReturnDLLString(ValueName(*Value))
EndProcedure

ProcedureDLL.i OpernoSetValue(*Value.Value, *SourceValue.Value)
  SetValue(*Value, *SourceValue)
EndProcedure
ProcedureDLL.i OpernoOperateValue(Operation.i, *LHS.Value, *RHS.Value)
  ProcedureReturn OperateValue(Operation, *LHS, *RHS)
EndProcedure
ProcedureDLL.i OpernoDuplicateValue(*Value.Value)
  ProcedureReturn DuplicateValue(*Value)
EndProcedure
ProcedureDLL.i OpernoPushDuplicatedValue(*Value.Value)
  ProcedureReturn PushDuplicatedValue(*Value)
EndProcedure
ProcedureDLL.s OpernoFormatValue(*Value.Value)
  _ReturnDLLString(FormatValue(*Value))
EndProcedure

ProcedureDLL.i OpernoCreateValue(*Class.Object)
  ProcedureReturn CreateValue(*Class)
EndProcedure
ProcedureDLL.i OpernoCreateIValue(Integer.i)
  ProcedureReturn CreateIValue(Integer)
EndProcedure
ProcedureDLL.i OpernoCreateFValue(Float.f)
  ProcedureReturn CreateFValue(Float)
EndProcedure
ProcedureDLL.i OpernoCreateQValue(Quad.q)
  ProcedureReturn CreateQValue(Quad)
EndProcedure
ProcedureDLL.i OpernoCreateDValue(Double.d)
  ProcedureReturn CreateDValue(Double)
EndProcedure
ProcedureDLL.i OpernoCreateBValue(State.i)
  ProcedureReturn CreateBValue(State)
EndProcedure
ProcedureDLL.i OpernoCreateSValue(String.s)
  ProcedureReturn CreateSValue(String)
EndProcedure
ProcedureDLL.i OpernoCreateQueueValue()
  ProcedureReturn CreateQueueValue()
EndProcedure
ProcedureDLL.i OpernoCreateBlockValue(Code.s)
  Protected *TokenQueue.Queue
  
  *TokenQueue = CreateQueue(@FreeValue())
  Parse(*TokenQueue, @Code)
  
  ProcedureReturn CreateBlockValue(*TokenQueue)
EndProcedure
ProcedureDLL.i OpernoCreatePValue(*Object.Object)
  ProcedureReturn CreatePValue(*Object)
EndProcedure
ProcedureDLL.i OpernoCreateReferenceValue(*Original.Value)
  ProcedureReturn CreateReferenceValue(*Original)
EndProcedure

ProcedureDLL.i OpernoPushValue(*Class.Object)
  ProcedureReturn PushValue(*Class)
EndProcedure
ProcedureDLL.i OpernoPushIValue(Integer.i)
  ProcedureReturn PushIValue(Integer)
EndProcedure
ProcedureDLL.i OpernoPushFValue(Float.f)
  ProcedureReturn PushFValue(Float)
EndProcedure
ProcedureDLL.i OpernoPushQValue(Quad.q)
  ProcedureReturn PushQValue(Quad)
EndProcedure
ProcedureDLL.i OpernoPushDValue(Double.d)
  ProcedureReturn PushDValue(Double)
EndProcedure
ProcedureDLL.i OpernoPushBValue(State.i)
  ProcedureReturn PushBValue(State)
EndProcedure
ProcedureDLL.i OpernoPushSValue(String.s)
  ProcedureReturn PushSValue(String)
EndProcedure
ProcedureDLL.i OpernoPushQueueValue()
  ProcedureReturn PushQueueValue()
EndProcedure
ProcedureDLL.i OpernoPushBlockValue(Code.s)
  Protected *TokenQueue.Queue
  
  *TokenQueue = CreateQueue(@FreeToken())
  Parse(*TokenQueue, @Code)
  
  ProcedureReturn PushBlockValue(*TokenQueue)
EndProcedure
ProcedureDLL.i OpernoPushPValue(*Object.Object)
  ProcedureReturn PushPValue(*Object)
EndProcedure
ProcedureDLL.i OpernoPushReferenceValue(*Original.Value)
  ProcedureReturn PushReferenceValue(*Original)
EndProcedure

ProcedureDLL.i OpernoPushQueue1(*Value1.Value)
  Protected *Queue.Value
  
  *Queue = CreateQueue(@FreeValue())
  AppendQueueItem(*Queue, *Value1)
  
  ProcedureReturn PushQueueValue(*Queue)
EndProcedure
ProcedureDLL.i OpernoPushQueue2(*Value1.Value, *Value2.Value)
  Protected *Queue.Value
  
  *Queue = CreateQueue(@FreeValue())
  AppendQueueItem(*Queue, *Value1)
  AppendQueueItem(*Queue, *Value2)
  
  ProcedureReturn PushQueueValue(*Queue)
EndProcedure
ProcedureDLL.i OpernoPushQueue3(*Value1.Value, *Value2.Value, *Value3.Value)
  Protected *Queue.Value
  
  *Queue = CreateQueue(@FreeValue())
  AppendQueueItem(*Queue, *Value1)
  AppendQueueItem(*Queue, *Value2)
  AppendQueueItem(*Queue, *Value3)
  
  ProcedureReturn PushQueueValue(*Queue)
EndProcedure
ProcedureDLL.i OpernoPushGroup1(Name1.s, *Value1.Value)
  Protected *Object.Object
  
  *Object = CreateGroup("")
  
  CreateVariable(Name1, *Value1, *Object)
  
  ProcedureReturn PushOValue(*Object)
EndProcedure
ProcedureDLL.i OpernoPushGroup2(Name1.s, *Value1.Value, Name2.s, *Value2.Value)
  Protected *Object.Object
  
  *Object = CreateGroup("")
  
  CreateVariable(Name1, *Value1, *Object)
  CreateVariable(Name2, *Value2, *Object)
  
  ProcedureReturn PushOValue(*Object)
EndProcedure
ProcedureDLL.i OpernoPushGroup3(Name1.s, *Value1.Value, Name2.s, *Value2.Value, Name3.s, *Value3.Value)
  Protected *Object.Object
  
  *Object = CreateGroup("")
  
  CreateVariable(Name1, *Value1, *Object)
  CreateVariable(Name2, *Value2, *Object)
  CreateVariable(Name3, *Value3, *Object)
  
  ProcedureReturn PushOValue(*Object)
EndProcedure

ProcedureDLL.i OpernoArgumentCount()
  ProcedureReturn *Current\ArgumentQueue\Count
EndProcedure
ProcedureDLL.i OpernoPopValue(*Result.Integer)
  ProcedureReturn PopValueAddress(*Result)
EndProcedure
ProcedureDLL.i OpernoPopIValue(*Result.Integer)
  ProcedureReturn PopIValue(*Result)
EndProcedure
ProcedureDLL.i OpernoPopFValue(*Result.Float)
  ProcedureReturn PopFValue(*Result)
EndProcedure
ProcedureDLL.i OpernoPopQValue(*Result.Quad)
  ProcedureReturn PopQValue(*Result)
EndProcedure
ProcedureDLL.i OpernoPopDValue(*Result.Double)
  ProcedureReturn PopDValue(*Result)
EndProcedure
ProcedureDLL.i OpernoPopBValue(*Result.Integer)
  ProcedureReturn PopBValue(*Result)
EndProcedure
ProcedureDLL.i OpernoPopSValue(*Result.String)
  If *Current\ArgumentQueue\Count
    StringCallback(ValueS(*Current\ArgumentQueue\First\Value), *Result)
    FreeFirstQueueItem(*Current\ArgumentQueue)
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure
ProcedureDLL.i OpernoPopPValue(*Result.Integer)
  ProcedureReturn PopPValue(*Result)
EndProcedure
ProcedureDLL.i OpernoPopVariable(*Result.Object)
  ProcedureReturn PopValue(*Result\Variable\Value)
EndProcedure

ProcedureDLL.i OpernoItemCount(*Value.Value)
  ProcedureReturn *Value\Queue\Count
EndProcedure
ProcedureDLL.i OpernoFirstItem(*Value.Value)
  ProcedureReturn *Value\Queue\First
EndProcedure
ProcedureDLL.i OpernoLastItem(*Value.Value)
  ProcedureReturn *Value\Queue\Last
EndProcedure
ProcedureDLL.i OpernoNextItem(*Item.QueueItem)
  ProcedureReturn *Item\N
EndProcedure
ProcedureDLL.i OpernoPreviousItem(*Item.QueueItem)
  ProcedureReturn *Item\P
EndProcedure
ProcedureDLL.i OpernoItem(*Value.Value, Index.i)
  ProcedureReturn SelectQueueItem(*Value\Queue, Index)
EndProcedure
ProcedureDLL.i OpernoItemValue(*Item.QueueItem)
  ProcedureReturn *Item\Value
EndProcedure
ProcedureDLL.i OpernoClearQueue(*Value.Value)
  ClearQueue(*Value\Queue)
EndProcedure
ProcedureDLL.i OpernoPrependItem(*Value.Value, *NewMember.Value)
  PrependQueueItem(*Value\Queue, *NewMember)
EndProcedure
ProcedureDLL.i OpernoAppendItem(*Value.Value, *NewMember.Value)
  AppendQueueItem(*Value\Queue, *NewMember)
EndProcedure
ProcedureDLL.i OpernoFreeItem(*Value.Value, *Item.QueueItem)
  FreeQueueItem(*Value\Queue, *Item)
EndProcedure

ProcedureDLL.i OpernoCreateGroup(Name.s, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateGroup(Name, *Super)
EndProcedure
ProcedureDLL.i OpernoChildCount(*Object.Object)
  ProcedureReturn *Object\Group\ObjectQueue\Count
EndProcedure
ProcedureDLL.i OpernoFirstChild(*Object.Object)
  If *Object\Group\ObjectQueue\First
    ProcedureReturn *Object\Group\ObjectQueue\First\Memory
  EndIf
EndProcedure
ProcedureDLL.i OpernoLastChild(*Object.Object)
  If *Object\Group\ObjectQueue\Last
    ProcedureReturn *Object\Group\ObjectQueue\Last\Memory
  EndIf
EndProcedure
ProcedureDLL.s OpernoGroupVariableName(*Object.Object)
  _ReturnDLLString(GroupVariableName(*Object))
EndProcedure

ProcedureDLL.i OpernoCreateVirtualTable(TableSize.i)
  ProcedureReturn CreateVirtualTable(TableSize)
EndProcedure
ProcedureDLL.i OpernoGetVirtualTable(*Object.Object)
  ProcedureReturn *Object\Group + _Sz(Object)
EndProcedure

ProcedureDLL.i OpernoCreateFunction(Name.s, *Address, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateAddressFunction(Name, *Address, *Super)
EndProcedure
ProcedureDLL.i OpernoCall(*Object.Object, *ArgumentQueue.Queue = -1, *This.Value = 0)
  ProcedureReturn Call(*Object, *ArgumentQueue, *This)
EndProcedure
ProcedureDLL.i OpernoArguments1(*Value1.Value)
  ProcedureReturn Arguments1(*Value1)
EndProcedure
ProcedureDLL.i OpernoArguments2(*Value1.Value, *Value2.Value)
  ProcedureReturn Arguments2(*Value1, *Value2)
EndProcedure

ProcedureDLL.i OpernoCreateVariable(Name.s, *Value.Value, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, *Value, *Super)
EndProcedure
ProcedureDLL.i OpernoCreateIVariable(Name.s, Integer.i, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateIValue(Integer), *Super)
EndProcedure
ProcedureDLL.i OpernoCreateFVariable(Name.s, Float.f, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateFValue(Float), *Super)
EndProcedure
ProcedureDLL.i OpernoCreateQVariable(Name.s, Quad.q, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateQValue(Quad), *Super)
EndProcedure
ProcedureDLL.i OpernoCreateDVariable(Name.s, Double.d, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateDValue(Double), *Super)
EndProcedure
ProcedureDLL.i OpernoCreateBVariable(Name.s, State.i, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateBValue(State), *Super)
EndProcedure
ProcedureDLL.i OpernoCreateSVariable(Name.s, String.s, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateSValue(String), *Super)
EndProcedure
ProcedureDLL.i OpernoCreatePVariable(Name.s, *Address.Object, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreatePValue(*Address), *Super)
EndProcedure
ProcedureDLL.i OpernoCreateVVariable(Name.s, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateVariable(Name, CreateVValue(), *Super)
EndProcedure
ProcedureDLL.i OpernoVariableValue(*Object.Object)
  ProcedureReturn *Object\Variable\Value
EndProcedure
ProcedureDLL.i OpernoVariableMemory(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Memory
EndProcedure
ProcedureDLL.i OpernoVariableI(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Integer\I
EndProcedure
ProcedureDLL.f OpernoVariableF(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Float\F
EndProcedure
ProcedureDLL.q OpernoVariableQ(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Quad\Q
EndProcedure
ProcedureDLL.d OpernoVariableD(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Double\D
EndProcedure
ProcedureDLL.i OpernoVariableB(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Integer\I
EndProcedure
ProcedureDLL.s OpernoVariableS(*Object.Object)
  _ReturnDLLString(*Object\Variable\Value\String\S)
EndProcedure
ProcedureDLL.i OpernoVariableP(*Object.Object)
  ProcedureReturn *Object\Variable\Value\Object
EndProcedure
ProcedureDLL.i OpernoSetVariable(*Object.Object, *Value.Value)
  ProcedureReturn SetValue(*Object\Variable\Value, *Value)
EndProcedure
ProcedureDLL.i OpernoSetIVariable(*Object.Object, Integer.i)
  *Object\Variable\Value\Integer\I = Integer
EndProcedure
ProcedureDLL.i OpernoSetFVariable(*Object.Object, Float.f)
  *Object\Variable\Value\Float\F = Float
EndProcedure
ProcedureDLL.i OpernoSetQVariable(*Object.Object, Quad.q)
  *Object\Variable\Value\Quad\Q = Quad
EndProcedure
ProcedureDLL.i OpernoSetDVariable(*Object.Object, Double.d)
  *Object\Variable\Value\Double\D = Double
EndProcedure
ProcedureDLL.i OpernoSetBVariable(*Object.Object, State.i)
  *Object\Variable\Value\Integer\I = State
EndProcedure
ProcedureDLL.i OpernoSetSVariable(*Object.Object, String.s)
  *Object\Variable\Value\String\S = String
EndProcedure
ProcedureDLL.i OpernoSetPVariable(*Object.Object, *Address.Object)
  *Object\Variable\Value\Object = *Address
EndProcedure

ProcedureDLL.s OpernoObjectName(*Object.Object)
  _ReturnDLLString(*Object\Name)
EndProcedure
ProcedureDLL.i OpernoRenameObject(*Object.Object, Name.s)
  *Object\Name = Name
EndProcedure
ProcedureDLL.i OpernoObjectType(*Object.Object)
  ProcedureReturn *Object\Type
EndProcedure
ProcedureDLL.s OpernoObjectPath(*Object.Object)
  _ReturnDLLString(ObjectPath(*Object))
EndProcedure
ProcedureDLL.i OpernoNextObject(*Object.Object)
  If *Object\Item And *Object\Item\N
    ProcedureReturn *Object\Item\N\Memory
  Else
    ProcedureReturn #Null
  EndIf
EndProcedure
ProcedureDLL.i OpernoPreviousObject(*Object.Object)
  If *Object\Item And *Object\Item\P
    ProcedureReturn *Object\Item\P\Memory
  Else
    ProcedureReturn #Null
  EndIf
EndProcedure
ProcedureDLL.i OpernoGet(Name.s, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn FindObject(*Super, Name)
EndProcedure
ProcedureDLL.i OpernoCreateReferenceObject(Name.s, *Original.Object, *Super.Object = -1)
  If *Super = -1
    *Super = Main\Object
  EndIf
  ProcedureReturn CreateReferenceObject(Name, *Original, *Super)
EndProcedure
ProcedureDLL.i OpernoExtractObject(*Super.Object, *Memory)
  ProcedureReturn ExtractObject(*Super, *Memory)
EndProcedure
ProcedureDLL.i OpernoFreeObject(*Object.Object)
  ProcedureReturn FreeObject(*Object)
EndProcedure

ProcedureDLL.i OpernoImportLibrary(LibraryName.s)
  Protected Library.i
  
  Library = OpenLibrary(#PB_Any, LibraryName + ".dll")
  If Not Library
    _Error("Can not import the specified library: " + #Q + LibraryName + #Q)
  EndIf
  
  CallFunction(Library, "OpernoGetFunctions", ?FunctionTable)
  CallFunction(Library, "InitLibrary")
EndProcedure

ProcedureDLL.i OpernoOpenUI()
  OpenUI(#False)
  Truncation = 0
EndProcedure
ProcedureDLL.i OpernoOpenGUI()
  OpenGUI()
  Truncation = 0
EndProcedure
ProcedureDLL.i OpernoOutput(Symbol.i, Text.s, Indent.i = 0)
  OutputFL(Symbol, Text, Indent)
EndProcedure
ProcedureDLL.i OpernoOutputHL()
  OutputHL()
EndProcedure
ProcedureDLL.s OpernoInput(Text.s, Indent.i = 0)
  _ReturnDLLString(InputFLT(#Symbol_Input, Text, Indent))
EndProcedure
ProcedureDLL.s OpernoInputCode(Indent.i = 0)
  InputC(Indent)
EndProcedure
ProcedureDLL.i OpernoCallback(*Callback)
  *MasterCallback = *Callback
EndProcedure
ProcedureDLL.i OpernoEnableSymbolOutput(State.i)
  OutputSymbols = State
EndProcedure
ProcedureDLL.i OpernoOpenConsole(Title.s = "Operno")
  Console = #True
  
  OpenConsole()
  ConsoleTitle(Title)
EndProcedure

ProcedureDLL.s OpernoVersion()
  _ReturnDLLString(#Version)
EndProcedure
ProcedureDLL.i OpernoOpenHelp()
  Interface_OpenHelp()
EndProcedure
ProcedureDLL.i OpernoGenerateHTMLFile(Filename.s, HTMLFilename.s)
  GenerateHTMLFile(Filename, HTMLFilename)
EndProcedure
ProcedureDLL.i OpernoConfigureHTMLGenerator()
  HTMLGeneratorConfiguration()
EndProcedure
ProcedureDLL.i OpernoOpenPreview()
  OpenPreview()
EndProcedure

ProcedureDLL.i OpernoClassMethodID(Method.s)
  ProcedureReturn ClassMethodID(Method)
EndProcedure

ProcedureDLL.i OpernoCreateCoordinateSystem(Width.i, Height.i, MinX.f, MinY.f, MaxX.f, MaxY.f)
  Protected *System.Std_CoordinateSystem
  
  *System = _New(Std_CoordinateSystem)
  
  *System\MinX   = MinX
  *System\MinY   = MinY
  *System\MaxX   = MaxX
  *System\MaxY   = MaxY
  
  *System\Width  = Width
  *System\Height = Height
  
  CoordinateSystemFactors(*System)
  
  *System\Image = CreateImage(#PB_Any, Width, Height)
  
  ProcedureReturn *System
EndProcedure
ProcedureDLL.i OpernoCoordinateSystemDrawBackground(*System, BackgroundColor.i = $FFFFFF, AxeColor.i = $808080, GridColor.i = $E0E0E0)
  CoordinateSystemDrawBackground(*System, BackgroundColor, AxeColor, GridColor)
EndProcedure
ProcedureDLL.i OpernoCoordinateSystemGraph(*System, Graph.s, Color.i = $000000, Thickness.i = 2)
  Protected *Function.Queue = CreateQueue(@FreeToken())
  
  Parse(*Function, @Graph) : _E()
  CoordinateSystemDrawGraph(*System, *Function, Color, Thickness)
EndProcedure
ProcedureDLL.i OpernoCoordinateSystemImageID(*System.Std_CoordinateSystem)
  Protected *CoordinateSystem.Std_CoordinateSystem = *System
  
  ProcedureReturn ImageID(*CoordinateSystem\Image)
EndProcedure
ProcedureDLL.i OpernoCoordinateSystemSaveImage(*System.Std_CoordinateSystem, Filename.s)
  SaveImage(*System\Image, Filename)
EndProcedure
ProcedureDLL.i OpernoFreeCoordinateSystem(*System)
  _Free(*System)
  ProcedureReturn #True
EndProcedure

ProcedureDLL.i OpernoSetStringCallback(*Address)
  PokeI(@StringCallback, *Address)
EndProcedure
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 780
; FirstLine = 206
; Folding = AAAgDAAAAAAAAAAAAAAAAAAAAAgBAA6
; EnableXP