;**************************************************************
;     Hilighter
;
; Autor: Josef Sniatecki
; Date: 10.10.2009
;   Josef Sniatecki 2009 (c)
;**************************************************************



Procedure.i HilightCode(Gadget.i, Code.s)
  Protected *Pointer.Character, *Start.Character, *Code.Character, String.s, Integer.i
  
  Code     = ReplaceString(Code, #N, Chr(10))
  *Pointer = @Code
  
  SendMessage_(GadgetID(Gadget), #EM_HIDESELECTION, #True, 0)
  
  Repeat
    Select *Pointer\C
      Case 'a' To 'z', 'A' To 'Z', '_', 192 To 255, ''
        ; Name:
        *Start = *Pointer
        *Pointer + 1
        Repeat
          Select *Pointer\C
            Case 'a' To 'z', 'A' To 'Z', '_', '0' To '9', 192 To 255, '!', '$', '?', ''
              *Pointer + 1
            Default
              *Pointer-1
              Break
          EndSelect
        ForEver
        ; Read name:
        String = PeekS(*Start, *Pointer-*Start + 1)
        ; Check predefined keywords:
        Integer = KeywordID(String)
        ; Generate Code:
        If Integer <> -1 Or String = "as"
          EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
          EditorGadgetSetStyle(Gadget, #PB_EditorGadget_Bold|#PB_EditorGadget_Underline)
          EditorGadgetSetColor(Gadget, $FF0000)
        ElseIf String = "this" Or String = "current" Or String = "case"
          EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
          EditorGadgetSetStyle(Gadget, #PB_EditorGadget_Bold)
          EditorGadgetSetColor(Gadget, $FFFFFF)
        Else
          EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
          EditorGadgetSetStyle(Gadget, 0)
          EditorGadgetSetColor(Gadget, $FFFFFF)
        EndIf
      Case '0' To '9'
        ; Number:
        *Start = *Pointer
        *Pointer + 1
        Select *Pointer\C
          Case '$'
            ; Binary:
            *Pointer + 1
            Repeat
              Select *Pointer\C
                Case '0', 'o', 'O', 'Q', '1', 'i', 'I'
                  *Pointer + 1
                Default
                  *Pointer-1
                  Break
              EndSelect
            ForEver
          Case '#'
            ; Hex:
            *Pointer + 1
            Repeat
              Select *Pointer\C
                Case '0' To '9', 'a' To 'f', 'A' To 'F'
                  *Pointer + 1
                Default
                  *Pointer - 1
                  Break
              EndSelect
            ForEver
          Case '0' To '9', '.', ''
            ; Decimal:
            Repeat
              Select *Pointer\C
                Case '0' To '9'
                  *Pointer + 1
                Case '.'
                  *Pointer + 1
                  If *Pointer\C = '.'
                    *Pointer - 2
                    Break
                  EndIf
                Case ''
                  Break
                Default
                  *Pointer - 1
                  Break
              EndSelect
            ForEver
          Default
            ; Only null:
            *Pointer - 1
        EndSelect
        ; Generate Code:
        EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
        EditorGadgetSetStyle(Gadget, 0)
        EditorGadgetSetColor(Gadget, $FFFF00)
      Case '"'
        ; String:
        *Start = *Pointer
        *Pointer = Parser_IgnoreString(*Pointer)
        EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
        EditorGadgetSetStyle(Gadget, 0)
        EditorGadgetSetColor(Gadget, $00FF00)
      Case '+', '-', '*', '/', '=', '<', '>', '&', '%', '|', '!'
        ; Operator:
        *Start = *Pointer
        *Pointer + 1
        Repeat
          Select *Pointer\C
            Case '+', '-', '*', '/', '=', '<', '>', '&', '%', '|', '!'
              *Pointer + 1
            Default
              *Pointer - 1
              Break
          EndSelect
        ForEver
        ; Generate code:
        EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
        EditorGadgetSetColor(Gadget, $0000FF)
        EditorGadgetSetStyle(Gadget, 0)
      Case '(', ')', '[', ']', '{', '}'
        ; Bracket:
        EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
        EditorGadgetSetColor(Gadget, $FFFFFF)
        EditorGadgetSetStyle(Gadget, #PB_EditorGadget_Bold)
      Case '\'
        *Pointer + 1
        If *Pointer\C = '\'
          EditorGadgetSelect(Gadget, *Pointer-@Code-1, *Pointer-@Code+1)
          EditorGadgetSetColor(Gadget, $FFFFFF)
          EditorGadgetSetStyle(Gadget, 0)
        Else
          *Pointer-1
          EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
          EditorGadgetSetColor(Gadget, $FFFFFF)
          EditorGadgetSetStyle(Gadget, 0)
        EndIf
      Case '.'
        *Pointer + 1
        If *Pointer\C = '.'
          *Pointer + 1
          If *Pointer\C = '.'
            EditorGadgetSelect(Gadget, *Pointer-@Code-2, *Pointer-@Code+1)
            EditorGadgetSetStyle(Gadget, 0)
            EditorGadgetSetColor(Gadget, $FFFFFF)
          Else
            *Pointer - 1
            EditorGadgetSelect(Gadget, *Pointer-@Code-1, *Pointer-@Code+1)
            EditorGadgetSetStyle(Gadget, 0)
            EditorGadgetSetColor(Gadget, $FFFFFF)
          EndIf
        Else
          *Pointer - 1
          EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
          EditorGadgetSetStyle(Gadget, 0)
          EditorGadgetSetColor(Gadget, $FFFFFF)
        EndIf
      Case ':'
        *Pointer + 1
        If *Pointer\C = ':'
          EditorGadgetSelect(Gadget, *Pointer-@Code-1, *Pointer-@Code+1)
          EditorGadgetSetColor(Gadget, $FFFFFF)
          EditorGadgetSetStyle(Gadget, 0)
        Else
          *Pointer-1
          EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
          EditorGadgetSetColor(Gadget, $FFFFFF)
          EditorGadgetSetStyle(Gadget, 0)
        EndIf
      Case '@'
        EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
        EditorGadgetSetColor(Gadget, $FFFFFF)
        EditorGadgetSetStyle(Gadget, 0)
      Case ',', ';'
      EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
        EditorGadgetSetColor(Gadget, $FFFFFF)
        EditorGadgetSetStyle(Gadget, 0)
      Case '#'
        ; Preprozessor symbol:
        *Pointer + 1
        Select *Pointer\C
          Case 'a' To 'z', 'A' To 'Z', '_', 192 To 255
            *Start = *Pointer
            *Pointer = Parser_GetName(*Pointer)
            EditorGadgetSelect(Gadget, *Start-@Code-1, *Pointer-@Code+1)
            EditorGadgetSetColor(Gadget, $0080FF)
            EditorGadgetSetStyle(Gadget, 0)
          Case '$'
            *Pointer + 1
            EditorGadgetSelect(Gadget, *Pointer-@Code-1, *Pointer-@Code+1)
            EditorGadgetSetColor(Gadget, $0080FF)
            EditorGadgetSetStyle(Gadget, 0)
          Default
            *Pointer - 1
            EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
            EditorGadgetSetColor(Gadget, $0080FF)
            EditorGadgetSetStyle(Gadget, 0)
        EndSelect
      Case 39
        *Start = *Pointer
        *Pointer = Parser_IgnoreComment(*Pointer)
        EditorGadgetSelect(Gadget, *Start-@Code, *Pointer-@Code+1)
        EditorGadgetSetColor(Gadget, $808080)
        EditorGadgetSetStyle(Gadget, #PB_EditorGadget_Italic)
      Case ' ', 9, 10
        EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
        EditorGadgetSetStyle(Gadget, 0)
        ; Nothing
      Case 0, 1
        Break
      Default
        EditorGadgetSelect(Gadget, *Pointer-@Code, *Pointer-@Code+1)
        EditorGadgetSetColor(Gadget, $FFFFFF)
        EditorGadgetSetStyle(Gadget, 0)
    EndSelect
    *Pointer + 1
  ForEver
  
  SendMessage_(GadgetID(Gadget), #EM_HIDESELECTION, #False, 0)
    
  ProcedureReturn *Pointer
EndProcedure
; IDE Options = PureBasic 4.40 Beta 7 (Windows - x86)
; CursorPosition = 37
; FirstLine = 23
; Folding = -
; EnableXP