;**************************************************************
;     IDs
;
; Autor: Josef Sniatecki
; Creation date: 07.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i KeywordID(Keyword.s)
  Protected ID.i
  
  ; Standard keywords:
  For ID = 0 To #KeywordCount
    If Keyword(ID) = Keyword
      ProcedureReturn ID
    EndIf
  Next
  ; Short keywords:
  Select Keyword
    Case "def?"
      ProcedureReturn #Keyword_IsDefined
    Case "ret"
      ProcedureReturn #Keyword_Return
  EndSelect
  ProcedureReturn -1
EndProcedure
Procedure.i ClassMethodID(Method.s)
  Protected ID.i
  
  For ID = 0 To #ClassMethodCount
    If ClassMethod(ID) = Method
      ProcedureReturn ID
    EndIf
  Next
  ProcedureReturn -1
EndProcedure
Procedure.i OperatorID(Characters.s)
  Protected ID.i
  
  For ID = 0 To #OperatorCount
    If Operator(ID) = Characters
      ProcedureReturn ID
    EndIf
  Next
  Select Characters
    Case "=<"
      ProcedureReturn #Operator_LessEqual
    Case "=>"
      ProcedureReturn #Operator_GreaterEqual
  EndSelect
  ProcedureReturn -1
EndProcedure
Procedure.i BracketID(Bracket.s)
  Protected ID.i
  
  For ID = 0 To #BracketCount
    If Bracket(ID) = Bracket Or ClosingBracket(ID) = Bracket
      ProcedureReturn ID
    EndIf
  Next
  ProcedureReturn -1
EndProcedure

Procedure.i StandardClass(Name.s)
  Select Name
    Case "integer", "int", "i"
      ProcedureReturn *IntegerClass
    Case "float", "f"
      ProcedureReturn *FloatClass
    Case "quad", "q"
      ProcedureReturn *QuadClass
    Case "double", "real", "d"
      ProcedureReturn *DoubleClass
    Case "boolean", "bool", "b"
      ProcedureReturn *BooleanClass
    Case "string", "str", "s"
      ProcedureReturn *StringClass
    Case "stringPointer", "char", "sp"
      ProcedureReturn *StringPointerClass
    Case "queue"
      ProcedureReturn *QueueClass
    Case "block"
      ProcedureReturn *BlockClass
    Case "pointer", "ptr", "p"
      ProcedureReturn *PointerClass
    Case "variant", "var", "v"
      ProcedureReturn *VariantClass
    Case "reference", "ref", "r"
      ProcedureReturn *ReferenceClass
  EndSelect
  ProcedureReturn #False
EndProcedure
Procedure.s ClassName(*Class)
  Select *Class
    Case *IntegerClass
      ProcedureReturn "int"
    Case *FloatClass
      ProcedureReturn "float"
    Case *QuadClass
      ProcedureReturn "quad"
    Case *DoubleClass
      ProcedureReturn "double"
    Case *BooleanClass
      ProcedureReturn "bool"
    Case *StringClass
      ProcedureReturn "str"
    Case *StringPointerClass
      ProcedureReturn "char"
    Case *QueueClass
      ProcedureReturn "queue"
    Case *BlockClass
      ProcedureReturn "block"
    Case *PointerClass
      ProcedureReturn "ptr"
    Case *ObjectClass
      ProcedureReturn "obj"
    Case *VariantClass
      ProcedureReturn "var"
    Case *ReferenceClass
      ProcedureReturn "ref"
    Default
      ProcedureReturn ObjectPath(*Class)
  EndSelect
EndProcedure

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = U-
; EnableXP
; CompileSourceDirectory