;**************************************************************
;     Manager
;
; Autor: Josef Sniatecki
; Date: 14.10.2009
;   Josef Sniatecki 2009 (c)
;**************************************************************





;******************************************
; Structures
;******************************************

Structure Function
  Name.s
  Type.c
  Arguments.s
  ArgumentNames.s
EndStructure



;******************************************
; Variables
;******************************************

Global SourceFile.i
Global DestinationFile.i

Global *Imports, *MasterFunctions

Global *Character.Character, *Start.Character
Global Line.s, Type.s

Global NewList Function.Function()



;******************************************
; Get DLL functions
;******************************************

SourceFile = ReadFile(#PB_Any, "..\Exports.pbi")
While ReadString(SourceFile) <> "; START:" : Wend

While Not Eof(SourceFile)
  Line = ReadString(SourceFile)
  If Line And Left(Line, 12) = "ProcedureDLL"
    AddElement(Function())
    *Character = @Line + 13
    
    Function()\Type = *Character\C
    *Character + 2
    
    Repeat
      *Character + 1
    Until *Character\C = '('
    Function()\Name = PeekS(@Line + 15, *Character - (@Line + 15))
    
    *Character + 1
    While *Character\C <> ')'
      Select *Character\C
        Case '.'
          *Character + 1
          *Start = *Character
          Repeat
            *Character + 1
          Until *Character\C = ',' Or *Character\C = ')' Or *Character\C = ' '
          Type = PeekS(*Start, *Character - *Start)
          Select Type
            Case "Object", "Value"
              Type = "Operno" + Type
            Case "Queue", "QueueItem", "Std_CoordinateSystem"
              Type = ""
          EndSelect
          If Type
            Function()\Arguments + "." + Type
          EndIf
          *Character - 1
        Case '='
          Function()\ArgumentNames = Left(Function()\ArgumentNames, Len(Function()\ArgumentNames) - 1)
          Function()\Arguments + "="
          *Character + 1
          *Start = *Character
          Repeat
            *Character + 1
          Until *Character\C = ',' Or *Character\C = ')'
          Function()\Arguments + PeekS(*Start, *Character - *Start)
          *Character - 1
        Case ')'
          Break
        Default
          Function()\Arguments     + Chr(*Character\C)
          Function()\ArgumentNames + Chr(*Character\C)
      EndSelect
      *Character + 1
    Wend
    
    While ReadString(SourceFile) <> "EndProcedure" : Wend
  ElseIf Line = ""
    AddElement(Function())
    Function()\Name = ""
  EndIf
Wend

CloseFile(SourceFile)



;******************************************
; Create function table
;******************************************

DestinationFile = CreateFile(#PB_Any, "..\FunctionTable.pbi")

WriteStringN(DestinationFile, "DataSection")
WriteStringN(DestinationFile, "  FunctionTable:")

ForEach Function()
  If Function()\Name
    WriteStringN(DestinationFile, "    Data.i @" + Function()\Name + "()")
  Else
    WriteStringN(DestinationFile, "    ")
  EndIf
Next

WriteStringN(DestinationFile, "EndDataSection")

CloseFile(DestinationFile)



;******************************************
; Generate imports (prototypes and so on...)
;******************************************

DestinationFile = CreateFile(#PB_Any, "Temp.txt")

ForEach Function()
  If Function()\Name
    If Function()\Type <> 's'
      WriteStringN(DestinationFile, "Prototype." + Chr(Function()\Type) + " " + Function()\Name + "(" + Function()\Arguments + ")")
    Else
      WriteStringN(DestinationFile, "Prototype.i " + Function()\Name + "_(" + Function()\Arguments + ")")
    EndIf
  Else
    WriteStringN(DestinationFile, "")
  EndIf
Next

WriteStringN(DestinationFile, Chr(13) + Chr(10) + Chr(13) + Chr(10))
WriteStringN(DestinationFile, "ProcedureDLL.i OpernoGetFunctions(*FunctionTable.Long)")

ForEach Function()
  If Function()\Name
    If Function()\Type <> 's'
      WriteStringN(DestinationFile, "  _OpernoImport(" + Function()\Name + ")")
    Else
      WriteStringN(DestinationFile, "  _OpernoImport(" + Function()\Name + "_)")
    EndIf
  Else
    WriteStringN(DestinationFile, "  ")
  EndIf
Next

WriteStringN(DestinationFile, "  ")
WriteStringN(DestinationFile, "  ; Get addresses of some important objects:")
WriteStringN(DestinationFile, "  *OpernoMainObject           = OpernoMainObject()")
WriteStringN(DestinationFile, "  *OpernoPreprocessorObject   = OpernoPreprocessorObject()")
WriteStringN(DestinationFile, "  *OpernoStandardLibrary      = OpernoStandardLibrary()")
WriteStringN(DestinationFile, "  *OpernoStandardClassLibrary = OpernoStandardClassLibrary()")
WriteStringN(DestinationFile, "  *OpernoIntegerClass         = OpernoIntegerClass()")
WriteStringN(DestinationFile, "  *OpernoFloatClass           = OpernoFloatClass()")
WriteStringN(DestinationFile, "  *OpernoQuadClass            = OpernoQuadClass()")
WriteStringN(DestinationFile, "  *OpernoDoubleClass          = OpernoDoubleClass()")
WriteStringN(DestinationFile, "  *OpernoBoolClass            = OpernoBoolClass()")
WriteStringN(DestinationFile, "  *OpernoStringClass          = OpernoStringClass()")
WriteStringN(DestinationFile, "  *OpernoQueueClass           = OpernoQueueClass()")
WriteStringN(DestinationFile, "  *OpernoBlockClass           = OpernoBlockClass()")
WriteStringN(DestinationFile, "  *OpernoPointerClass         = OpernoPointerClass()")
WriteStringN(DestinationFile, "  *OpernoObjectClass          = OpernoObjectClass()")

WriteStringN(DestinationFile, "  ")
WriteStringN(DestinationFile, "  ; Send the address of the " + Chr(34) + "OpernoSetStringCallback" + Chr(34) + ":")
WriteStringN(DestinationFile, "  OpernoSetStringCallback(@OpernoStringCallback())")

WriteStringN(DestinationFile, "EndProcedure")

WriteStringN(DestinationFile, "")

ForEach Function()
  If Function()\Type = 's'
    WriteStringN(DestinationFile, "Procedure.s " + Function()\Name + "(" + Function()\Arguments + ")")
    WriteStringN(DestinationFile, "  ProcedureReturn PeekS(" + Function()\Name + "_(" + Function()\ArgumentNames + "))")
    WriteStringN(DestinationFile, "EndProcedure")
  EndIf
Next

*Imports = AllocateMemory(Lof(DestinationFile))
FileSeek(DestinationFile, 0)
ReadData(DestinationFile, *Imports, Lof(DestinationFile))

CloseFile(DestinationFile)



;******************************************
; Read master functions
;******************************************

SourceFile = ReadFile(#PB_Any, "MasterFunctions.txt")

*MasterFunctions = AllocateMemory(Lof(SourceFile))
ReadData(SourceFile, *MasterFunctions, Lof(SourceFile))

CloseFile(SourceFile)



;******************************************
; Create import sources
;******************************************

CopyFile("Template.txt", "..\..\DLL\Operno.pbi")
DestinationFile = OpenFile(#PB_Any, "..\..\DLL\Operno.pbi")
FileSeek(DestinationFile, Lof(DestinationFile))

WriteData(DestinationFile, *Imports, MemorySize(*Imports))
WriteData(DestinationFile, *MasterFunctions, MemorySize(*MasterFunctions))

CloseFile(DestinationFile)



CopyFile("Template.txt", "..\..\Libraries\SDK\Operno.pbi")
DestinationFile = OpenFile(#PB_Any, "..\..\Libraries\SDK\Operno.pbi")
FileSeek(DestinationFile, Lof(DestinationFile))

WriteData(DestinationFile, *Imports, MemorySize(*Imports))

CloseFile(DestinationFile)



CopyFile("..\..\DLL\Operno.pbi", "..\..\..\..\Includes\Operno\Operno.pbi")
CopyFile("..\..\DLL\Operno.dll", "..\..\..\..\Includes\Operno\Operno.dll")





MessageRequester("Operno - Manager", "All tasks finished")
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 75
; FirstLine = 62
; Folding = -
; EnableXP