;**************************************************************
;     Misc
;
; Autor: Josef Sniatecki
; Creation date: 03.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i ExtractIArray(Array Integer.i(1), *Memory.Integer, *EndOfMemory)
  Protected Index.i
  
  While *Memory < *EndOfMemory
    Integer(Index) = *Memory\I
    *Memory + _Sz(Integer)
    Index + 1
  Wend
EndProcedure
Procedure.i ExtractSArray(Array String.s(1), *Memory, *EndOfMemory)
  Protected Index.i
  
  While *Memory < *EndOfMemory
    String(Index) = PeekS(*Memory)
    *Memory + (Len(String(Index)) + 1) * _Sz(Character)
    Index + 1
  Wend
EndProcedure

Procedure.i TurnColor(Color.i)
  ; Thanks to cxAlex & Kaeru Garman
  
  Protected TurnedColor.i, *SourceByte.Byte, *DestinationByte.Byte
  
  *SourceByte = @Color
  *DestinationByte = @TurnedColor + 2*_Sz(Byte)
  
  *DestinationByte\B = *SourceByte\B
  *SourceByte + _Sz(Byte) : *DestinationByte - _Sz(Byte)
  *DestinationByte\B = *SourceByte\B
  *SourceByte + _Sz(Byte) : *DestinationByte - _Sz(Byte)
  *DestinationByte\B = *SourceByte\B
  
  ProcedureReturn TurnedColor
EndProcedure
Procedure.s CamelCase(Text.s)
  Protected *Character.Character, Result.s, *Finish
  
  *Finish    = @Text + Len(Text) - _Sz(Character)
  *Character = @Text
  
  While *Character\C
    If *Character\C = ' ' And *Character <> *Finish
      *Character + _Sz(Character)
      If *Character\C <> ' '
        Result + UCase(Chr(*Character\C))
      Else
        *Character - _Sz(Character)
      EndIf
    Else
      Result + Chr(*Character\C)
    EndIf
    *Character + _Sz(Character)
  Wend
  
  ProcedureReturn Result
EndProcedure
Procedure.s SpacedCase(Text.s)
  Protected *Character.Character, Result.s
  
  *Character = @Text
  While *Character\C
    Select *Character\C
      Case 'A' To 'Z'
        Result + " " + LCase(Chr(*Character\C))
      Default
        Result + Chr(*Character\C)
    EndSelect
    *Character + _Sz(Character)
  Wend
  
  ProcedureReturn Result
EndProcedure
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 93
; FirstLine = 62
; Folding = -
; EnableXP